gtkmm: Gtk::EventControllerFocus Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::EventControllerFocus Class Reference
Event Controllers and Gestures

Event controller for focus. More...

`#include <gtkmm/eventcontrollerfocus.h>`

Inheritance diagram for Gtk::EventControllerFocus:
[legend]

## Public Member Functions
| EventControllerFocus (EventControllerFocus &&src) noexcept
EventControllerFocus & | operator= (EventControllerFocus &&src) noexcept
| ~EventControllerFocus () noexcept override
GtkEventControllerFocus * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventControllerFocus * | gobj () const
| Provides access to the underlying C GObject.
GtkEventControllerFocus * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | contains_focus () const
| Returns `true` if focus is within self or one of its children.
bool | is_focus () const
| Returns `true` if focus is within self, but not one of its children.
Glib::SignalProxy< void()> | signal_enter ()
Glib::SignalProxy< void()> | signal_leave ()
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| `true` if focus is in the controllers widget itself, as opposed to in a descendent widget.
Glib::PropertyProxy_ReadOnly< bool > | property_contains_focus () const
| `true` if focus is contained in the controllers widget.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController &&src) noexcept
EventController & | operator= (EventController &&src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to.
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< EventControllerFocus > | create ()
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| EventControllerFocus ()
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::EventControllerFocus > | wrap (GtkEventControllerFocus *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Event controller for focus.

Gtk::EventControllerFocus is an event controller meant for situations where you need to know where the focus is.

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ EventControllerFocus() [1/2]

Gtk::EventControllerFocus::EventControllerFocus | ( | EventControllerFocus && | src | ) |
| noexcept

## ◆ ~EventControllerFocus()

Gtk::EventControllerFocus::~EventControllerFocus | ( |  | ) |
| overridenoexcept

## ◆ EventControllerFocus() [2/2]

Gtk::EventControllerFocus::EventControllerFocus | ( |  | ) |
| protected

## Member Function Documentation

## ◆ contains_focus()

bool Gtk::EventControllerFocus::contains_focus | ( |  | ) | const

Returns `true` if focus is within self or one of its children.

Returns
  `true` if focus is within self or one of its children.

## ◆ create()

static Glib::RefPtr< EventControllerFocus > Gtk::EventControllerFocus::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gtk::EventControllerFocus::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkEventControllerFocus * Gtk::EventControllerFocus::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkEventControllerFocus * Gtk::EventControllerFocus::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkEventControllerFocus * Gtk::EventControllerFocus::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_focus()

bool Gtk::EventControllerFocus::is_focus | ( |  | ) | const

Returns `true` if focus is within self, but not one of its children.

Returns
  `true` if focus is within self, but not one of its children.

## ◆ operator=()

EventControllerFocus & Gtk::EventControllerFocus::operator= | ( | EventControllerFocus && | src | ) |
| noexcept

## ◆ property_contains_focus()

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerFocus::property_contains_focus | ( |  | ) | const

`true` if focus is contained in the controllers widget.

See property_is_focus() for whether the focus is in the widget itself or inside a descendent.

When handling focus events, this property is updated before signal_enter() or signal_leave() are emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_is_focus()

Glib::PropertyProxy_ReadOnly< bool > Gtk::EventControllerFocus::property_is_focus | ( |  | ) | const

`true` if focus is in the controllers widget itself, as opposed to in a descendent widget.

See also property_contains_focus().

When handling focus events, this property is updated before signal_enter() or signal_leave() are emitted.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ signal_enter()

Glib::SignalProxy< void()> Gtk::EventControllerFocus::signal_enter | ( |  | ) |

Slot Prototype:
  `void on_my_enter()`

Flags: Run Last

Emitted whenever the focus enters into the widget or one of its descendents.

Note that this means you may not get an signal_enter() signal even though the widget becomes the focus location, in certain cases (such as when the focus moves from a descendent of the widget to the widget itself). If you are interested in these cases, you can monitor the property_is_focus() property for changes.

## ◆ signal_leave()

Glib::SignalProxy< void()> Gtk::EventControllerFocus::signal_leave | ( |  | ) |

Slot Prototype:
  `void on_my_leave()`

Flags: Run Last

Emitted whenever the focus leaves the widget hierarchy that is rooted at the widget that the controller is attached to.

Note that this means you may not get a signal_leave() signal even though the focus moves away from the widget, in certain cases (such as when the focus moves from the widget to a descendent). If you are interested in these cases, you can monitor the property_is_focus() property for changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::EventControllerFocus > wrap | ( | GtkEventControllerFocus * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.